# -*- coding: cp1252 -*-
"""Information sur une map multijoueur"""

import distob
import gameinfo
import network
import effet

game_rules = None

event_dict = {}

class GameRules(distob.distob):

    saved = {}
    GameSpeed = 2
    AlamoTime = 2
    UnitNumber = 3
    share_vision = 1
    enhanced_unit_lethality = 2
    map_ressource = 1
    ressource_at_start = 2
    pow_generation = 1
    ressource_collect_speed = 1
    share_ressource = 0
    allow_wmd_strike = 1
    allow_air_strike = 1
    allow_mercenaries = 0
    AltVictory_DestroyHQ = 0
    AltVictory_WMDRun = 0
    AltVictory_PrisonnerRun = 0
    MiniMode = 4
    M1ID_number_of_round = 1

    __fields__ = (
        'GameSpeed',
        'AlamoTime',
        'UnitNumber',
        'share_vision',
        'enhanced_unit_lethality',
        'map_ressource',
        'ressource_at_start',
        'pow_generation',
        'ressource_collect_speed',
        'share_ressource',
        'allow_wmd_strike',
        'allow_air_strike',
        'allow_mercenaries',
        'AltVictory_DestroyHQ',
        'AltVictory_WMDRun',
        'AltVictory_PrisonnerRun',
        'MiniMode',
        'M1ID_number_of_round',
    )

    def init(self):
        global game_rules
        game_rules = self
        for e in event_dict.itervalues():
            effet.RunEffetInstantane( e )

    def _on_GameSpeed(self, oldval, newval):
        effet.RunEffetInstantane( event_dict["GameSpeed"] )

    def _on_AlamoTime(self, oldval, newval):
        effet.RunEffetInstantane( event_dict["AlamoTime"] )

    def _on_share_vision(self, oldval, newval):
        effet.RunEffetInstantane( event_dict["share_vision"] )

    def _on_enhanced_unit_lethality(self, oldval, newval):
        effet.RunEffetInstantane( event_dict["enhanced_unit_lethality"] )

    def _on_map_ressource(self, oldval, newval):
        effet.RunEffetInstantane( event_dict["map_ressource"] )

    def _on_ressource_at_start(self, oldval, newval):
        effet.RunEffetInstantane( event_dict["ressource_at_start"] )

    def _on_pow_generation(self, oldval, newval):
        effet.RunEffetInstantane( event_dict["pow_generation"] )

    def _on_ressource_collect_speed(self, oldval, newval):
        effet.RunEffetInstantane( event_dict["ressource_collect_speed"] )

    def _on_share_ressource(self, oldval, newval):
        effet.RunEffetInstantane( event_dict["share_ressource"])

    def _on_allow_wmd_strike(self, oldval, newval):
        effet.RunEffetInstantane( event_dict["allow_wmd_strike"] )

    def _on_allow_air_strike(self, oldval, newval):
        effet.RunEffetInstantane( event_dict["allow_air_strike"] )

    def _on_allow_mercenaries(self, oldval, newval):
        effet.RunEffetInstantane( event_dict["allow_mercenaries"] )

    def _on_UnitNumber(self, oldval, newval):
        effet.RunEffetInstantane( event_dict["UnitNumber"] )

    def _on_AltVictory_DestroyHQ(self, oldval, newval):
        effet.RunEffetInstantane( event_dict["AltVictory_DestroyHQ"] )

    def _on_AltVictory_WMDRun(self, oldval, newval):
        effet.RunEffetInstantane( event_dict["AltVictory_WMDRun"] )

    def _on_AltVictory_PrisonnerRun(self, oldval, newval):
        effet.RunEffetInstantane( event_dict["AltVictory_PrisonnerRun"] )

    def _on_MiniMode(self, oldval, newval):
        effet.RunEffetInstantane( event_dict["MiniMode"] )

    def _on_M1ID_number_of_round(self, oldval, newval):
        effet.RunEffetInstantane( event_dict["M1ID_number_of_round"] )

    def set_defaut(self):
        self.GameSpeed = 2
        self.AlamoTime = 2
        self.UnitNumber = 3
        self.share_vision = 1
        self.enhanced_unit_lethality = 2
        self.map_ressource = 1
        self.ressource_at_start = 2
        self.pow_generation = 1
        self.ressource_collect_speed = 1
        self.share_ressource = 0
        self.allow_wmd_strike = 1
        self.allow_air_strike = 1
        self.allow_mercenaries = 0
        self.AltVictory_DestroyHQ = 0
        self.AltVictory_WMDRun = 0
        self.AltVictory_PrisonnerRun = 0
        self.M1ID_number_of_round = 1

    def OpenMenu(self):
        self.saved = {}
        for key in self.__class__.__fields__:
            self.saved[key] = getattr(self, key)

    def Restore(self):
        for key in self.__class__.__fields__:
            setattr(self, key, self.saved[key])
        self.saved = {}

class FakeGameRules(object):
    pass

class load_gamerules(object):
    """Gestionnaire de sauvegarde utilis pour les rgles gamerules."""
    def __getstate__(self):
        state = None
        if game_rules:
            state = FakeGameRules()
            for key in GameRules.__fields__:
                state.__setattr__(key, game_rules.__getattribute__(key))
        return {'rules': state}

    def __setstate__(self, state):
        self.__dict__.update(state)

    def __call__(self):
        global game_rules
        game_rules = self.rules

import save_manager
save_handler = save_manager.add_object(load_gamerules())

